



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python 中为什么不需要重载 参数*arg和**args</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python 中为什么不需要重载 参数*arg和**args</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:44:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>函数重载主要是为了解决两个问题。</p>
<p>（1）可变参数类型。</p>
<p>（2） 可变参数个数。</p>
<p>另外，一个基本的设计原则是，仅仅当两个函数除了参数类型和参数个数不同以外，其功能是完全相同的，此时才使用函数重载，如果两个函数的功能其实不同，那么不应当使用重载，而应当使用一个名字不同的函数。</p>
<p>好吧，那么对于情况 （1），函数功能相同，但是参数类型不同，python 如何处理？答案是根本不需要处理，因为 python 可以接受任何类型的参数，如果函数的功能相同，那么不同的参数类型在 python 中很可能是相同的代码，没有必要做成两个不同函数。</p>
<p>那么对于情况 （2），函数功能相同，但参数个数不同，python 如何处理？答案就是缺省参数。对那些缺少的参数设定为缺省参数即可解决问题。因为你假设函数功能相同，那么那些缺少的参数终归是需要用的。</p>
<p>好了，鉴于情况 （1） 跟 情况 （2） 都有了解决方案，python 自然就不需要函数重载了。</p>
<p>这里顺便说一下python中参数传递时候的*arg和**args，看几个小栗子就一清二楚了：</p>
<p>第一个小栗子：</p>
<div>
<pre class="prettyprint linenums">def test1(farg,*args):<br />
     print ("farg:",farg)<br />
     for value in args:<br />
         print ("args:",value)

test1(1,"two",3,"")</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1034798/201903/1034798-20190320223942504-633576628.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1034798/201903/1034798-20190320224011465-652613410.png" /></p>
<p>下面的例子更加清晰，<strong>定义的时候 * 的作用 将位置实参 装配成元组，**</strong><strong>&nbsp;的作用 将关键字实参 装配成字典</strong></p>
<div>
<pre class="prettyprint linenums">def test1(x, y, z, *args):<br />
    print (x, y, z, args)

def test2(x, y, z, **kwargs):<br />
    print (x, y, z, kwargs)

test1(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15)<br />
test2(1, 2, 3, a=4, b=5)</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1034798/201903/1034798-20190320224113783-655190934.png" /></p>
<p>下面的例子是调用的时候&nbsp;* 的作用将元组或列表 打散成位置参数进行参数传递，** 的作用将字典打散成关键字参数进行参数传递</p>
<div>
<pre class="prettyprint linenums">def test3(x, y, z):<br />
    print (x, y, z)

x = [1, 2, 3]<br />
x1 = ('q','w','e')<br />
y = {'x': 1, 'y': 2, 'z': 3}<br />
test3(*x1)<br />
test3(*x)<br />
test3(**y)</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1034798/201903/1034798-20190320224250136-1352736311.png" /></p>
<p><strong>简单来说，Python中为什么不需要重载，重载要解决的是参数类型和参数个数的问题，对于类型，python不像是c语言整型要写int，字符串要写str,,,这些python都不需要。</strong></p>
<p><strong>那么需要解决的就是传递参数个数问题，此时python可以传递列表呀，字典呀，可以使用*arg和**args呀，所以python根本不需要重载。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7m3p1q.html">CSS Icon 项目地址  小图标-用css写成的</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zkk2d8.html">UIScrollView出现位移问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qny1ex8.html">python sqlite 插入的数据含有变量，结果不一致</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93r1rz9.html">ol新属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8orem18.html">ie11媒体查询以及其他hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oxmp18.html">&lbrack;OpenCV&rsqb;（1）安装与测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgl5d8.html">jquery节点操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydvxlgq.html">Python核心编程--学习笔记--6--序列（上）字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1j0r9.html">octopress添加回到顶部按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjyw4j8.html">springboot&lpar;三&rpar;：Spring boot中Redis的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yr4xw8.html">hdu2050 折线分割平面---递推</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4mn69.html">深挖 NPM 机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zygdn19.html">阶段02JavaWeb基础day01html&amp;amp&semi;css</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dv0eq.html">Windows下安装配置Flutter</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjvgr9.html">《设计模式》学习&amp;amp&semi;理解&amp;amp&semi;总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o16re1q.html">js时间与时间戳互相转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjw2w79.html">css 如何实现图片等比例缩放</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eojyj9.html">【struts2】继承ActionSupport类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv1y38.html">MAC下Android的Eclipse开发环境的搭建 转自MacroCheng</a>
		</li>
						<li><a href="https://www.batexi.com/a/902jzyoq.html">Unity2017烘焙参数设置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wvmgwq.html">【iCore4 双核心板&lowbar;uC&sol;OS-II】例程二：任务的建立与删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy40n39.html">C语言  &amp;&num;183&semi;  年龄巧合</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1gmzpq.html">Java自定义注解的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj5le09.html">Geoserver GeoWebCache 切图失败 This requested used more time than allowed and has been forcefully stopped&period; Max rendering time is 60&period;0s</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51j1dq.html">81For全栈技术网</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4we4z9.html">多级分类标签&lbrace;dede&colon;channelartlist&rcub;实现当前栏目颜色高亮显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllve5xq.html">unity3d IL2CPP for android</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w7o2wq.html">CocoaPods更新过程中出现的坑及解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvjpxq.html">&lbrack;原&rsqb;CentOS 7 chrony 笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4wyxe9.html">&lbrack;原&rsqb;Jenkins&lpar;十七&rpar; jenkins再出发之配置SVN</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
